////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>

#ifdef HAVE_LIBPCRECPP
#include <pcrecpp.h>
#endif

#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!

using namespace vdrlive;

bool checkNew(RecordingsTreePtr recordingsTree, std::vector<std::string> p) {
	bool newR = false;
	RecordingsMap::iterator iter;
	for (iter = recordingsTree->begin(p); iter != recordingsTree->end(p); iter++) {
		RecordingsItemPtr recItem = iter->second;
		if(!recItem->IsDir())
			newR |= recItem->Recording()->GetResume() <= 0;
		else {
			std::vector<std::string> pp(p);
			pp.push_back(recItem->Name());
			newR |= checkNew(recordingsTree, pp);
		}
	}
	return newR;
}



#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_item_dir_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_item_dir_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_item_file_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_item_file_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    rec_item_dir_type rec_item_dir;
    rec_item_file_type rec_item_file;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "\314\001\000\000\315\001\000\000\316\001\000\000\317\001\000\000\363\001\000\000\376\001"
  "\000\000\001\002\000\000\275\002\000\000\023\t\000\000\024\t\000\000\026\t\000\000\027\t\000\000\031\t\000\000\032\t"
  "\000\000U\t\000\000h\t\000\000k\t\000\000l\t\000\000\002\n\000\000X\n\000\000w\n\000\000\221\n\000\000\222\n\000\000"
  "\223\n\000\000\225\n\000\000\257\n\000\000\260\n\000\000\277\n\000\000\360\n\000\000\377\n\000\000\033\013\000\000#"
  "\013\000\000$\013\000\000&\013\000\000P\013\000\000[\013\000\000\245\013\000\000\260\013\000\000\265\013\000\000\351"
  "\013\000\000\030\014\000\000P\014\000\000X\014\000\000\223\014\000\000\234\014\000\000\301\014\000\000\312\014\000"
  "\000\324\014\000\000\325\014\000\000\327\014\000\000\366\014\000\000\370\014\000\000\003\015\000\000\022\015\000\000"
  "\023\015\000\000\025\015\000\0008\015\000\000D\015\000\000M\015\000\000T\015\000\000U\015\000\000X\015\000\000Y\015"
  "\000\000Z\015\000\000[\015\000\000\134\015\000\000]\015\000\000^\015\000\000`\015\000\000j\015\000\000y\015\000\000}"
  "\015\000\000~\015\000\000\177\015\000\000\201\015\000\000\324\015\000\000\371\015\000\000'\016\000\000u\016\000\000w"
  "\016\000\000\300\016\000\000\301\016\000\000\303\016\000\000\376\016\000\000\010\017\000\000\027\017\000\000\032\017"
  "\000\0007\017\000\000@\017\000\000D\017\000\000\206\017\000\000\257\017\000\000\266\017\000\000\340\017\000\000\370"
  "\017\000\000\003\020\000\000\037\020\000\000$\020\000\000%\020\000\000+\020\000\0001\020\000\0008\020\000\000K\020"
  "\000\000\177\020\000\000\201\020\000\000\202\020\000\000\312\020\000\000\313\020\000\000\323\020\000\000\360\020\000"
  "\000\367\020\000\000\377\020\000\000\000\021\000\000\002\021\000\000\003\021\000\000\n\n\n\n<html>\n\t<head>\n\t\t<ti"
  "tle>VDR-Live - </title>\n\t\t\n\t\t\n\t\t<script type=\"text/javascript\" src=\"treeview.js\"></script>\n\t\t<script "
  "type=\"text/javascript\"><!--\n\t\tfunction filterRecordings(filter)\n\t\t{\n\t\t\twindow.location.href = \"recording"
  "s.html\?sort=&filter=\" + encodeURIComponent(filter.value);\n\t\t}\n\t\tfunction ExpandAll()\n\t\t{\n\t\t\tvar openNo"
  "des = \"\";\n\t\t\trecordingNodes = window.document.getElementsBySelector(\"ul.recordingslist\");\n\t\t\tfor (idx = 0"
  "; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t"
  "\t\t\t\trecordingNodes[idx].style.display = 'block';\n\t\t\t\t\topenNodes += recordingNodes[idx].id + \",\"; \n\t\t\t"
  "\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector(\"img.recording_expander\");\n\t\t\tfor (idx "
  "= 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = \"img/minus.png\";\n\t\t\t}\n\t\t\tfolderNode"
  "s = window.document.getElementsBySelector(\"img.recording_folder\");\n\t\t\tfor (idx = 0; idx < folderNodes.length; i"
  "dx++) {\n\t\t\t\tfolderNodes[idx].src = \"img/folder_open.png\";\n\t\t\t}\n\t\t\tcreateCookie( cookieNameRec, openNod"
  "es, 14 );\n\t\t}\n\t\tfunction CollapseAll()\n\t\t{\n\t\t\trecordingNodes = window.document.getElementsBySelector(\"u"
  "l.recordingslist\");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].pare"
  "ntNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'none';\n\t\t\t\t}\n\t\t\t}\n\t\t"
  "\texpandNodes = window.document.getElementsBySelector(\"img.recording_expander\");\n\t\t\tfor (idx = 0; idx < expandN"
  "odes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = \"img/plus.png\";\n\t\t\t}\n\t\t\tfolderNodes = window.document"
  ".getElementsBySelector(\"img.recording_folder\");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfo"
  "lderNodes[idx].src = \"img/folder_closed.png\";\n\t\t\t}\n\t\t\teraseCookie( cookieNameRec );\n\t\t}\n\t\t//--></scri"
  "pt>\n\t</head>\n\t<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t\n\t\t<div class=\"in"
  "halt\">\n\t\t\t<div class=\"boxheader\"><div><div></div></div></div>\n\t\t\t\n\t\t\t<form method=\"post\" name=\"reco"
  "rdings\" action=\"recordings.ecpp\">\n\t\t\t<div class=\"recordings\">\n\t\t\t<ul class=\"recordingslist\" style=\"di"
  "splay: block;\">\n\n\t\t\t</ul>\n\t\t\t</div>\n\t\t\t<div class=\"withmargin\">\n\t\t\t\t<button class=\"red\" type="
  "\"submit\"></button>\n\t\t\t</div>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n\n\t<li class=\"recording\">"
  "\n\t\t\n\t\t<ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n\t\t</ul>\n\t</li>\n\t<li class=\"re"
  "cording\">\n\t   \n\t</li>\n\n\n\n<a href=\"recordings.html\?sort=name&filter=\" alt=\"\" /></a>\n<span class=\"sep\""
  ">|</span>\n<a href=\"recordings.html\?sort=date&filter=\" alt=\"\" /></a>\n<span class=\"sep\">|</span>\n<span class="
  "\"label bold\">:&nbsp;<input type=\"text\" name=\"filter\" value=\"\" id=\"filter\" onchange=\"filterRecordings(this)"
  "\" />&nbsp;</span>\n<span class=\"sep\">|</span>\n<img onclick=\"ExpandAll()\" src=\"\" alt=\"\" />\n<img onclick=\"C"
  "ollapseAll()\" src=\"\" alt=\"\" />\n<br />\n\n\n\n<a href=\"recordings.html\?todel=\" ><img src=\"\" alt=\"\" /></a>"
  "\n\n\n<a href=\"edit_recording.html\?recid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\n\n\n\n\n\n\n\n<img src=\"\" alt"
  "=\"on_dvd\"  />\n\n\n\n\n\t<div class=\"recording_item\" onclick=\"Toggle(this)\">\n\t\t<div class=\"recording_imgs\""
  "><img class=\"recording_expander\" src=\"\" alt=\"\" /><img class=\"recording_folder\" src=\"\" alt=\"\" /></div>\n\t"
  "\t<div class=\"recording_spec\">\n\t\t\t<div class=\"recording_name\"></div>\n\t    </div>\n\t\t<div class=\"recordin"
  "g_actions\">&nbsp;</div>\n\t</div>\n\n\n\n\t<div class=\"recording_item\">\n\t<div class=\"recording_imgs\"><img src="
  "\"\" alt=\"on_dvd\"  /><input type=\"checkbox\" name=\"\" value=\"\" /></div>\n\t<div class=\"recording_spec\">\n\t\t"
  "<div class=\"recording_day\"></div>\n\t\t<div class=\"recording_duration\"></div>\n\t\t<div class=\"recording_errors"
  "\"><img src=\"\" width = \"16px\" alt=\"\"  /> </div>\n\t\t<div class=\"recording_name\"><a ><br /><span></span><span"
  ">&nbsp;</span></a></div>\n\t</div>\n\t<div class=\"recording_actions\">\n\t\t\n\t\t<img src=\"img/transparent.png\" a"
  "lt=\"\" width=\"16px\" height=\"16px\" />\n\t\t\n\t</div>\n\t<div class=\"recording_arch\"></div>\n\t</div>\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    rec_item_dir(*this, "rec_item_dir"),
    rec_item_file(*this, "rec_item_file"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
  // </%args>

#line 46 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 51 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 52 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 53 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 57 "recordings.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

currentSort = LiveSetup().GetLastSortingMode();
if (!sort.empty()) {
	if (sort == "date")
		currentSort = (currentSort == "dateasc") ? "datedesc" : "dateasc";
	else if (sort == "name")
		currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
	LiveSetup().SetLastSortingMode(currentSort);
}
currentFilter = filter;

pageTitle = tr("Recordings");

deleteResult = "";
if (!todel.empty()) {
	if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
	deletions.push_back(todel);
}
#if TNTVERSION >= 30000
typedef std::vector<std::string> deletions_type;
#endif
for (deletions_type::const_iterator it = deletions.begin(); it != deletions.end(); ++it) {
	if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
		RemoveRecordingTask task(*it);
		LiveTaskManager().Execute(task);
		if (!task.Result())
			deleteResult += std::string() + tr("ERROR:") + " " + task.Error() + "<br/>";
		else
			deleteResult += std::string() + tr("Deleted recording:") + " " + StringReplace(task.RecName(), "~", "/") + "<br/>";
	}
	else {
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
	}
}
deletions.clear();

int FreeMB, UsedMB;
#if APIVERSNUM > 20101
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
#else
int Percent = VideoDiskSpace(&FreeMB, &UsedMB);
#endif
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));

  // <& pageelems.doc_type ...
  { 
#line 107 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 107 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 110 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 111 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 111 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 112 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 112 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n\t\t<script type="text/javascript" src="treeview.js"></script>\n\t\t<script type="text/javascript"><!--\n\t\tfunction filterRecordings(filter)\n\t\t{\n\t\t\twindow.location.href = "recordings.html\?sort=
#line 117 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[7]; // &filter=" + encodeURIComponent(filter.value);\n\t\t}\n\t\tfunction ExpandAll()\n\t\t{\n\t\t\tvar openNodes = "";\n\t\t\trecordingNodes = window.document.getElementsBySelector("ul.recordingslist");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'block';\n\t\t\t\t\topenNodes += recordingNodes[idx].id + ","; \n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector("img.recording_expander");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = "img/minus.png";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("img.recording_folder");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = "img/folder_open.png";\n\t\t\t}\n\t\t\tcreateCookie( cookieNameRec, openNodes, 14 );\n\t\t}\n\t\tfunction CollapseAll()\n\t\t{\n\t\t\trecordingNodes = window.document.getElementsBySelector("ul.recordingslist");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'none';\n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector("img.recording_expander");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = "img/plus.png";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("img.recording_folder");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = "img/folder_closed.png";\n\t\t\t}\n\t\t\teraseCookie( cookieNameRec );\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 160 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 160 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[8]; // \n
#line 161 "recordings.ecpp"

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[9]; // \t\t
  // <& menu ...
  { 
#line 164 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 164 "recordings.ecpp"
    _tnt_cq4.add( "active", ("recordings"));
#line 164 "recordings.ecpp"
    _tnt_cq4.add( "component", ("recordings.delete_error"));
#line 164 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[10]; // \n
#line 165 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[11]; // \t\t
  // <& menu ...
  { 
#line 168 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 168 "recordings.ecpp"
    _tnt_cq5.add( "active", ("recordings"));
#line 168 "recordings.ecpp"
    _tnt_cq5.add( "component", ("recordings.sort_options"));
#line 168 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[12]; // \n
#line 169 "recordings.ecpp"

}

  reply.out() << _tntChunks[13]; // \t\t<div class="inhalt">\n\t\t\t<div class="boxheader"><div><div>
#line 173 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[14]; // </div></div></div>\n
#line 174 "recordings.ecpp"

#if VDRVERSNUM >= 20301
			int rec_cnt;
			{
				LOCK_RECORDINGS_READ;
				rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
			}
			if (rec_cnt == 0) {
#else
			if (Recordings.Count() == 0) { // Access VDRs global cRecordings Recordings instance.
#endif

  reply.out() << _tntChunks[15]; // \t\t\t
#line 186 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[16]; // \n
#line 187 "recordings.ecpp"

			} else {

  reply.out() << _tntChunks[17]; // \t\t\t<form method="post" name="recordings" action="recordings.ecpp">\n\t\t\t<div class="recordings">\n\t\t\t<ul class="recordingslist" style="display: block;">\n
  // <& recordings.recordings_item ...
  { 
#line 193 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 193 "recordings.ecpp"
    _tnt_cq6.add( "filter", (currentFilter));
#line 193 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[18]; // \n\t\t\t</ul>\n\t\t\t</div>\n\t\t\t<div class="withmargin">\n\t\t\t\t<button class="red" type="submit">
#line 197 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[19]; // </button>\n\t\t\t</div>\n\t\t\t</form>\n
#line 200 "recordings.ecpp"

			}

  reply.out() << _tntChunks[20]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[21]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[22]; // \n
  reply.out() << _tntChunks[23]; // \n\n
  reply.out() << _tntChunks[31]; // \n
  reply.out() << _tntChunks[32]; // \n\n
  reply.out() << _tntChunks[47]; // \n
  reply.out() << _tntChunks[48]; // \n\n
  reply.out() << _tntChunks[53]; // \n
  reply.out() << _tntChunks[54]; // \n\n
  reply.out() << _tntChunks[59]; // \n
  reply.out() << _tntChunks[60]; // \n\n\n
  reply.out() << _tntChunks[66]; // \n
  reply.out() << _tntChunks[67]; // \n\n
  reply.out() << _tntChunks[72]; // \n
  reply.out() << _tntChunks[73]; // \n\n
  reply.out() << _tntChunks[80]; // \n
  reply.out() << _tntChunks[81]; // \n\n
  reply.out() << _tntChunks[111]; // \n
  reply.out() << _tntChunks[112]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > path = qparam.getvector< std::string >("path");
int level = qparam.get< int >("level", ( 0));
int counter = qparam.get< int >("counter", ( 0));
std::string idHash = qparam.get< std::string >("idHash", ( ""));
  // </%args>

#line 46 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 51 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 52 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 53 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 218 "recordings.ecpp"

RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
RecordingsMap::iterator iter;
RecordingsMap::iterator end = recordingsTree->end(path);
std::list<RecordingsItemPtr> recItems;
std::list<RecordingsItemPtr>::iterator recIter;

for (iter = recordingsTree->begin(path); iter != end; ++iter) {
	RecordingsItemPtr recItem = iter->second;
	if (recItem->IsDir()) {
		recItems.push_back(recItem);
	}
}
if (currentSort == "namedesc")
	recItems.sort(RecordingsItemPtrCompare::ByDescendingName);
else
	recItems.sort(RecordingsItemPtrCompare::ByAscendingName);
for (recIter = recItems.begin(); recIter != recItems.end(); ++recIter) {
	RecordingsItemPtr recItem = *recIter;
	counter++;

	/* search trough directory for new recordings */
        bool newR = false;
	if ( LiveSetup().GetMarkNewRec() ) {
           std::vector<std::string> p(path); 
	   p.push_back(recItem->Name()); 
	   newR = checkNew(recordingsTree, p);; 
        }

  reply.out() << _tntChunks[24]; // \t<li class="recording">\n\t\t
  // <& rec_item_dir ...
  { 
#line 248 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 248 "recordings.ecpp"
    _tnt_cq7.add( "level", (recItem->Level()));
#line 248 "recordings.ecpp"
    _tnt_cq7.add( "name", (recItem->Name()));
#line 248 "recordings.ecpp"
    _tnt_cq7.add( "newR", (newR ? "_new" : ""));
#line 248 "recordings.ecpp"
  main().rec_item_dir(request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[25]; // \n
#line 249 "recordings.ecpp"

#if TNT_QUERYPARAMS_NO_BOOL
		tnt::QueryParams recItemParams(qparam);
#else
		tnt::QueryParams recItemParams(qparam, false);
#endif
#if TNTVERSION >= 30000
                typedef std::vector<std::string> path_type;
#endif
		for (path_type::const_iterator i = path.begin(); i != path.end(); ++i) {
			recItemParams.add("path", *i);
		}
#if TNTVERSION >= 30000
		recItemParams.add("path[]", recItem->Name());
#else
		recItemParams.add("path", recItem->Name());
#endif
		recItemParams.add("level", lexical_cast<std::string, int>(level + 1));
		recItemParams.add("filter", filter);
		std::string combinedId = recItem->Name() + "_";
		combinedId += counter + "_" + level;
		idHash = MD5Hash(combinedId);

  reply.out() << _tntChunks[26]; // \t\t<ul id="fldr_
#line 272 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[27]; // " class="recordingslist" style="display: none;">\n
#line 273 "recordings.ecpp"

		callComp("recordings.recordings_item", request, reply, recItemParams);

  reply.out() << _tntChunks[28]; // \t\t</ul>\n\t</li>\n
#line 278 "recordings.ecpp"

}
recItems.clear();
for (iter = recordingsTree->begin(path); iter != end; ++iter) {
	RecordingsItemPtr recItem = iter->second;
	if (!recItem->IsDir()) {
		recItems.push_back(recItem);
	}
}
if (currentSort == "dateasc")
	recItems.sort(RecordingsItemPtrCompare::ByAscendingDate);
else if (currentSort == "datedesc")
	recItems.sort(RecordingsItemPtrCompare::ByDescendingDate);
else if (currentSort == "namedesc")
	recItems.sort(RecordingsItemPtrCompare::ByDescendingName);
else
	recItems.sort(RecordingsItemPtrCompare::ByAscendingName);
for (recIter = recItems.begin(); recIter != recItems.end(); ++recIter) {
		RecordingsItemPtr recItem = *recIter;
		// xgettext:no-c-format
		std::string day(FormatDateTime(tr("%a,"), recItem->StartTime()));
		std::string dayLen(lexical_cast<std::string, int>(day.length() - 1) + ".25em;");
		// TRANSLATORS: recording duration format HH:MM
		std::string duration(recItem->Duration() < 0 ? "" : FormatDuration(tr("(%d:%02d)"), recItem->Duration() / 60, recItem->Duration() % 60));
		std::string newR = "";
                if ( LiveSetup().GetMarkNewRec() ) {
		   newR = (recItem->Recording()->GetResume() <= 0 ? "_new" : "");
                }
		std::string shortDescr(recItem->RecInfo()->ShortText() ? recItem->RecInfo()->ShortText() : "");
#if VDRVERSNUM >= 20505
		int recordingErrors = recItem->RecInfo()->Errors();
#else
		int recordingErrors = -1;
#endif
		std::string description(recItem->RecInfo()->Description() ? recItem->RecInfo()->Description() : "");
#if TNTVERSION >= 30000
                shortDescr = CorrectNonUTF8(&shortDescr); // cleanup invalid UTF-8 characters
                description = CorrectNonUTF8(&description); // cleanup invalid UTF-8 characters
                                                            // Tntnet30 throw: tntnet.worker - http-Error: 500 character conversion failed
#endif
		std::string hint(tr("Click to view details."));
		if (!shortDescr.empty()) hint = shortDescr + "<br />" + hint;
		else if (!description.empty()) hint = description + "<br />" + hint;
#ifdef HAVE_LIBPCRECPP
		pcrecpp::RE re(filter.c_str(), pcrecpp::UTF8().set_caseless(true));
		if (filter.empty() || re.PartialMatch(recItem->Name()) || re.PartialMatch(shortDescr) || re.PartialMatch(description))
#endif
		{

  reply.out() << _tntChunks[29]; // \t<li class="recording">\n\t   
  // <& rec_item_file ...
  { 
#line 328 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "archived", (RecordingsManager::GetArchiveDescr(recItem->Recording())));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "day", (day));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "dayLen", (dayLen));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "duration", (duration));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "hint", (hint));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "id", (recItem->Id()));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "level", (recItem->Level()));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "name", (recItem->Name()));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "newR", (newR));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "recordingErrors", (recordingErrors));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "shortDescr", (shortDescr));
#line 328 "recordings.ecpp"
    _tnt_cq8.add( "startTime", (recItem->StartTime()));
#line 328 "recordings.ecpp"
  main().rec_item_file(request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[30]; // \n\t</li>\n
#line 330 "recordings.ecpp"

		}
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 46 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 51 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 52 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 53 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 339 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[33]; // <a href="recordings.html\?sort=name&filter=
#line 340 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[34]; // " alt="" />
#line 340 "recordings.ecpp"
  reply.sout() << ( tr("Sort by name") );
  reply.out() << _tntChunks[35]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=date&filter=
#line 342 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[36]; // " alt="" />
#line 342 "recordings.ecpp"
  reply.sout() << ( tr("Sort by date") );
  reply.out() << _tntChunks[37]; // </a>\n
#line 343 "recordings.ecpp"

#ifdef HAVE_LIBPCRECPP

  reply.out() << _tntChunks[38]; // <span class="sep">|</span>\n<span class="label bold">
#line 347 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[39]; // :&nbsp;<input type="text" name="filter" value="
#line 347 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[40]; // " id="filter" onchange="filterRecordings(this)" />&nbsp;
  // <& tooltip.help ...
  { 
#line 347 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 347 "recordings.ecpp"
    _tnt_cq9.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 347 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[41]; // </span>\n
#line 348 "recordings.ecpp"

#endif

  reply.out() << _tntChunks[42]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 352 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[43]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 352 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 352 "recordings.ecpp"
    _tnt_cq10.add( "text", (tr("Expand all folders")));
#line 352 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[44]; // />\n<img onclick="CollapseAll()" src="
#line 353 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[45]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 353 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 353 "recordings.ecpp"
    _tnt_cq11.add( "text", (tr("Collapse all folders")));
#line 353 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[46]; // />\n<br />\n
#line 355 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 46 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 51 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 52 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 53 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 364 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[49]; // <a href="recordings.html\?todel=
#line 364 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[50]; // " 
  // <& tooltip.hint ...
  { 
#line 364 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 364 "recordings.ecpp"
    _tnt_cq12.add( "text", (tr("Delete this recording from hard disc!")));
#line 364 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[51]; // ><img src="
#line 364 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[52]; // " alt="" /></a>
#line 364 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 46 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 51 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 52 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 53 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 373 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[55]; // <a href="edit_recording.html\?recid=
#line 373 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[56]; // "><img src="
#line 373 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[57]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 373 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 373 "recordings.ecpp"
    _tnt_cq13.add( "text", (tr("Edit recording")));
#line 373 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[58]; //  /></a>
#line 373 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
  // </%args>

#line 46 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 51 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 52 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 53 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& pageelems.ajax_action_href ...
  { 
#line 384 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 384 "recordings.ecpp"
    _tnt_cq14.add( "action", "play_recording");
#line 384 "recordings.ecpp"
    _tnt_cq14.add( "alt", "");
#line 384 "recordings.ecpp"
    _tnt_cq14.add( "image", "play.png");
#line 384 "recordings.ecpp"
    _tnt_cq14.add( "param", (id));
#line 384 "recordings.ecpp"
    _tnt_cq14.add( "tip", (tr("play this recording.")));
#line 384 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[61]; // \n
  // <& pageelems.m3u_playlist_recording ...
  { 
#line 385 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 385 "recordings.ecpp"
    _tnt_cq15.add( "recid", (id));
#line 385 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[62]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 386 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 386 "recordings.ecpp"
    _tnt_cq16.add( "title", (title));
#line 386 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[63]; // \n
  // <& recordings.edit_rec ...
  { 
#line 387 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 387 "recordings.ecpp"
    _tnt_cq17.add( "id", (id));
#line 387 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[64]; // \n
  // <& recordings.del_rec ...
  { 
#line 388 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 388 "recordings.ecpp"
    _tnt_cq18.add( "id", (id));
#line 388 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[65]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
  // </%args>

#line 46 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 51 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 52 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 53 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[68]; // <img src="
#line 398 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[69]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 398 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 398 "recordings.ecpp"
    _tnt_cq19.add( "text", (archived));
#line 398 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[70]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 399 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 399 "recordings.ecpp"
    _tnt_cq20.add( "title", (title));
#line 399 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[71]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_item_dir_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_item_dir " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string name = qparam.get< std::string >("name");
int level = qparam.get< int >("level");
std::string newR = qparam.get< std::string >("newR");
std::string collapseimg = qparam.get< std::string >("collapseimg", ( "plus.png"));
std::string folderimg = qparam.get< std::string >("folderimg", ( "folder_closed.png"));
  // </%args>

#line 46 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 51 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 52 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 53 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[74]; // \t<div class="recording_item" onclick="Toggle(this)">\n\t\t<div class="recording_imgs">
#line 413 "recordings.ecpp"
 reply.out() << StringRepeat(level - 1, "<img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" />"); 
  reply.out() << _tntChunks[75]; // <img class="recording_expander" src="
#line 413 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", collapseimg) );
  reply.out() << _tntChunks[76]; // " alt="" /><img class="recording_folder" src="
#line 413 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", folderimg) );
  reply.out() << _tntChunks[77]; // " alt="" /></div>\n\t\t<div class="recording_spec">\n\t\t\t<div class="recording_name
#line 415 "recordings.ecpp"
  reply.sout() << ( newR );
  reply.out() << _tntChunks[78]; // ">
#line 415 "recordings.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[79]; // </div>\n\t    </div>\n\t\t<div class="recording_actions">&nbsp;</div>\n\t</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_item_file_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_item_file " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string name = qparam.get< std::string >("name");
int level = qparam.get< int >("level");
std::string id = qparam.get< std::string >("id");
std::string day = qparam.get< std::string >("day");
std::string dayLen = qparam.get< std::string >("dayLen");
time_t startTime = qparam.get< time_t >("startTime");
std::string duration = qparam.get< std::string >("duration");
std::string hint = qparam.get< std::string >("hint");
std::string shortDescr = qparam.get< std::string >("shortDescr");
int recordingErrors = qparam.get< int >("recordingErrors");
std::string newR = qparam.get< std::string >("newR");
std::string archived = qparam.get< std::string >("archived");
  // </%args>

#line 46 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 51 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 52 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 53 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[82]; // \t<div class="recording_item">\n\t<div class="recording_imgs">
#line 439 "recordings.ecpp"
 reply.out() << StringRepeat(level, "<img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" />"); 
#line 440 "recordings.ecpp"
 if (!archived.empty()) { 
  reply.out() << _tntChunks[83]; // <img src="
#line 440 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[84]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 440 "recordings.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 440 "recordings.ecpp"
    _tnt_cq21.add( "text", (archived));
#line 440 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[85]; //  />
#line 440 "recordings.ecpp"
 } else {
#if TNTVERSION >= 30000
		std::string deletionsName = "deletions[]";
#else
		std::string deletionsName = "deletions";
#endif

  reply.out() << _tntChunks[86]; // <input type="checkbox" name="
#line 446 "recordings.ecpp"
  reply.sout() << ( deletionsName );
  reply.out() << _tntChunks[87]; // " value="
#line 446 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[88]; // " />
#line 446 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[89]; // </div>\n\t<div class="recording_spec">\n\t\t<div class="recording_day">
#line 448 "recordings.ecpp"
  reply.sout() << ( FormatDateTime(tr("%a,"), startTime) + std::string(" ") + FormatDateTime(tr("%b %d %y"), startTime) + std::string(" ") + FormatDateTime(tr("%I:%M %p"), startTime) );
  reply.out() << _tntChunks[90]; // </div>\n\t\t<div class="recording_duration">
#line 449 "recordings.ecpp"
  reply.sout() << ( duration );
  reply.out() << _tntChunks[91]; // </div>\n
#line 450 "recordings.ecpp"

#if VDRVERSNUM >= 20505
std::string recording_errors_icon;
std::string recordingErrorsStr;

if (recordingErrors == 0) {
  recording_errors_icon = "NoRecordingErrors.png";
  recordingErrorsStr = tr("No recording errors");
}
if (recordingErrors == -1) {
  recording_errors_icon = "NotCheckedForRecordingErrors.png";
  recordingErrorsStr = tr("Recording errors unknown") ;
}
if (recordingErrors >   0) {
  recording_errors_icon = "RecordingErrors.png";
  recordingErrorsStr = tr("Number of recording errors:");
  recordingErrorsStr += " " + std::to_string(recordingErrors);
}

  reply.out() << _tntChunks[92]; // \t\t<div class="recording_errors"><img src="
#line 469 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", recording_errors_icon) );
  reply.out() << _tntChunks[93]; // " width = "16px" alt="" 
  // <& tooltip.hint ...
  { 
#line 469 "recordings.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 469 "recordings.ecpp"
    _tnt_cq22.add( "text", (recordingErrorsStr));
#line 469 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[94]; //  /> </div>\n
#line 470 "recordings.ecpp"

#endif

  reply.out() << _tntChunks[95]; // \t\t<div class="recording_name
#line 473 "recordings.ecpp"
  reply.sout() << ( newR );
  reply.out() << _tntChunks[96]; // "><a 
  // <& tooltip.hint ...
  { 
#line 473 "recordings.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 473 "recordings.ecpp"
    _tnt_cq23.add( "text", (hint));
#line 473 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq23);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 473 "recordings.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 473 "recordings.ecpp"
    _tnt_cq24.add( "domId", (id));
#line 473 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[97]; // >
#line 473 "recordings.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[98]; // <br />
#line 473 "recordings.ecpp"
if ((name != shortDescr) && (!shortDescr.empty())) {
  reply.out() << _tntChunks[99]; // <span>
#line 473 "recordings.ecpp"
  reply.sout() << ( shortDescr );
  reply.out() << _tntChunks[100]; // </span>
#line 473 "recordings.ecpp"
 } else { 
  reply.out() << _tntChunks[101]; // <span>&nbsp;</span>
#line 473 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[102]; // </a></div>\n\t</div>\n\t<div class="recording_actions">\n
#line 476 "recordings.ecpp"

		if (archived.empty()) {

  reply.out() << _tntChunks[103]; // \t\t
  // <& recordings.rec_tools ...
  { 
#line 479 "recordings.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 479 "recordings.ecpp"
    _tnt_cq25.add( "id", (id));
#line 479 "recordings.ecpp"
    _tnt_cq25.add( "title", (name));
#line 479 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "rec_tools"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[104]; // \n
#line 480 "recordings.ecpp"

		}
		else {

  reply.out() << _tntChunks[105]; // \t\t<img src="img/transparent.png" alt="" width="16px" height="16px" />\n\t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 485 "recordings.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 485 "recordings.ecpp"
    _tnt_cq26.add( "title", (name));
#line 485 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[106]; // \n
#line 486 "recordings.ecpp"

		}

  reply.out() << _tntChunks[107]; // \t</div>\n
#line 490 "recordings.ecpp"

	if (! archived.empty()) {

  reply.out() << _tntChunks[108]; // \t<div class="recording_arch">
#line 493 "recordings.ecpp"
  reply.sout() << ( archived );
  reply.out() << _tntChunks[109]; // </div>\n
#line 494 "recordings.ecpp"

	}

  reply.out() << _tntChunks[110]; // \t</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 46 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 51 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 52 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 53 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 503 "recordings.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 503 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[113]; // \n
#line 504 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
